$! generate C/FORTRAN/DCL "include" file from MACRO definitions
$!
$ ver_p = 'f$verify(0,f$environment("verify_image"))'
$!
$! wjm may 1985 (FORTRAN output only)
$! chg 15-nov-1985 wjm: use SYS$OUTPUT from MACRO directly, new FORGBLINI.MAR
$! mod 22-nov-1985 wjm: FORGBLINI in same directory as this file
$! fix 11-oct-1989 wjm: clear STS$M_INHIB_MSG, so $exit gives error msg
$! chg 26-nov-1990 wjm: adapt to VMS 5.4; re-organize into 1 command procedure
$!				(after ideas by J.Leichter & E.Gavron)
$! mod 15-oct-1993 wjm: adapt to AXP VMS (V1.5)
$! mod 27-oct-1993 wjm: add SET SYMBOL/SCOPE, delete output file on error
$! fix 27-dec-1993 wjm: consistent output of OSname
$!
$! input:	module $'p1' in SYS$LIBRARY:STARLET.MLB or LIB.MLB
$! output:	depending upon p2:
$!			"C" (default)	=> []'p1'.H
$!			"FORTRAN"	=> []'p1'.FD
$!			"DCL"		=> []'p1'.COM
$! files required: <same directory as this COMfile>DEFGBLINI.MAR
$!
$!*****
$!
$ set := SET
$ set symbol/scope=(nolocal,noglobal)
$ if "''GENDEF\DEBUG'" then set verify=procedure
$!
$ set noon
$!
$ p2 = f$edit(p2,"upcase,collapse,uncomment")
$ lang = "C"
$ ftype = ".H"
$ if p2.eqs."" .or. p2.eqs."C" then goto p2ok
$ lang = "FORTRAN"
$ ftype = ".FD"
$ if f$locate(p2,"FORTRAN").eq.0 then goto p2ok
$ lang = "DCL"
$ ftype = ".COM"
$ if f$locate(p2,"DCL").eq.0 then goto p2ok
$ write SYS$OUTPUT "%-F-Bad parameter p2: C, FORTRAN, or DCL expected"
$ xstat = 4
$ goto done
$!
$p2ok:
$ alpha = f$getsyi("CPU").gt.127
$ vmsv = f$element(0,".",f$getsyi("version"))	! major ...
$ vmsv = f$extract(1,f$length(vmsv)-1,vmsv)	! ... w/o initial letter
$ vmsv2 = f$element(1,".",f$getsyi("version"))	! minor ...
$ macro054 = alpha .or. -
	((vmsv.eqs."5" .and. vmsv2 .ges."4") .or. vmsv.gts."5")
$!
$ defgblini=f$parse("DEFGBLINI.MAR;",f$env("procedure"))
$!
$ osname = "VMS " + f$edit(f$getsyi("version"),"trim")
$ if alpha then osname = "OpenVMS " + f$edit(f$getsyi("version"),"trim")
$!
$ open/write GENDEF_TMP []GENDEF.TMP
$ write GENDEF_TMP ".macro	JL_EMIT	SYM,VALUE"
$ goto write_'lang'
$!
$write_C:
$ write GENDEF_TMP ".if lt %locate(<->,VALUE)-%length(VALUE)"
$ write GENDEF_TMP "	.print;#define	SYM	(VALUE)"
$ write GENDEF_TMP ".iff"
$ write GENDEF_TMP "	.print;#define	SYM	VALUE"
$ write GENDEF_TMP ".endc"
$ write GENDEF_TMP ".endm	JL_EMIT"
$ write GENDEF_TMP "	.print;/*"
$ write GENDEF_TMP "	.print; * definitions created by GENDEF at " +-
		f$time() + " (" + osname + ")"
$ write GENDEF_TMP "	.print; */"
$ write GENDEF_TMP "	$" + p1
$ write GENDEF_TMP "	.print;/*"
$ write GENDEF_TMP "	.print; * end of definitions created by GENDEF"
$ write GENDEF_TMP "	.print; */"
$ goto write__end
$!
$write_FORTRAN:
$ write GENDEF_TMP "	.print;	integer*4 SYM"
$ write GENDEF_TMP "	.print;	parameter (SYM = VALUE)"
$ write GENDEF_TMP ".endm	JL_EMIT"
$ write GENDEF_TMP "	.print;*"
$ write GENDEF_TMP "	.print;* definitions created by GENDEF at " +-
		f$time() + " (" + osname + ")"
$ write GENDEF_TMP "	.print;*"
$ write GENDEF_TMP "	$" + p1
$ write GENDEF_TMP "	.print;*"
$ write GENDEF_TMP "	.print;* end of definitions created by GENDEF"
$ write GENDEF_TMP "	.print;*"
$ goto write__end
$!
$write_DCL:
$ write GENDEF_TMP "	.print;$ SYM == VALUE"
$ write GENDEF_TMP ".endm	JL_EMIT"
$ write GENDEF_TMP "	.print;$!*"
$ write GENDEF_TMP "	.print;$! definitions created by GENDEF at " +-
		f$time() + " (" + osname + ")"
$ write GENDEF_TMP "	.print;$!*"
$ write GENDEF_TMP "	$" + p1
$ write GENDEF_TMP "	.print;$!*"
$ write GENDEF_TMP "	.print;$! end of definitions created by GENDEF"
$ write GENDEF_TMP "	.print;$!*"
$ goto write__end
$!
$write__end:
$ write GENDEF_TMP "	.end"
$ close GENDEF_TMP
$!
$ outputfn = p1 + ftype
$ macoutfn = outputfn
$ if alpha then macoutfn = "[]GENDEF.TMP2"
$ timestamp = f$cvtim("")
!
$ if .not.macro054 then -			! pre-5.4 MACRO: .PRINT output
	define/user SYS$ERROR 'macoutfn'	! ... goes to SYS$ERROR
$ if macro054 then -
	create 'macoutfn'
$ if macro054 then -				! 5.4 MACRO: .PRINT output
	define/user SYS$OUTPUT 'macoutfn'	! ... goes to SYS$OUTPUT
$ if macro054 then -				! ... (appended) ...
	define/user SYS$ERROR  NL:		! ... and somehow to SYS$ERROR
$!
$ if .not.alpha then -
	$ macro/nolist/noobject -
		'defgblini'+SYS$DISK:[]GENDEF.TMP+SYS$LIBRARY:LIB/LIB
$ if alpha then -
	$ macro/migrate/nolist/noobject -
		'defgblini'+SYS$DISK:[]GENDEF.TMP+SYS$LIBRARY:LIB/LIB
$ xstat = $status.and.%xEFFFFFFF		! want to signal again
$!
$ delete []GENDEF.TMP;
$!
$ if xstat .and. alpha then goto alpha_strip
$ if xstat then goto done
$!
$ macoutfn = f$search(macoutfn)
$ if macoutfn.nes."" .and. f$cvtim(f$file(macoutfn,"cdt")).ges.timestamp then -
	delete/log 'macoutfn'
$!
$done:
$ exit xstat + f$verify(ver_p,f$environment("verify_image"))*0
$!
$!
$!***** ALPHA MACRO32 makes .print output into long error messages ...
$!
$alpha_strip:
$!
$ prefix = "%AMAC-I-GENINFO, 0 "
$!
$ create 'outputfn'
$ open/read GENDEF_TMP 'macoutfn'
$ open/append GENDEF_OUT 'outputfn'
$cloop:
$ read/end=cloopend GENDEF_TMP line
$ if f$length(line).gt.0 .and. f$locate(prefix,line).eq.0 then -
	write GENDEF_OUT (line - prefix)
$ goto cloop
$cloopend:
$ close GENDEF_OUT
$ close GENDEF_TMP
$!
$ delete []GENDEF.TMP2;
$!
$ goto done
